# Chookpen - A simple messaging service

## What is Chookpen?

Chookpen is a lightweight, secure-ish chat server implementation focused on simplicity and real-time communication. It features user authentication, persistent message history, real-time updates via WebSockets, and supports both traditional HTTP endpoints and WebSocket connections for flexible integration. It uses very little resources on a system, often using a maximum of 20mb. Chookpen is BETA SOFTWARE, and MAY BE BUGGY! Don't expect too much.

## A guide to this repository

Chookpen is split up into multiple parts, the server and different reference clients for different platforms. For extensive documentation of all parts of Chookpen, a repository wiki is being worked on which will be released soon. For now, if you want to learn more about Chookpen, visit each folder.

## Acknowledgments

Chookpen relies on a lot of FOSS software, and wouldn't be possible without it! Here's some quick links to the original projects if you're interested:

### [Javalin](https://javalin.io)

An easy to use web server for Kotlin and Java. Chookpen wouldn't be possible without it!

### [Gradle](https://gradle.org)

The build tool for compiling Chookpen. It just works!

### [Kotlin](https://kotlinlang.org)

The language Chookpen is coded in. How else does it work?

### [OpenJDK](https://openjdk.org)
